SystemOrganization addCategory: #'Jason-Tests'!
SystemOrganization addCategory: #'Jason-Core'!

!BlockClosure methodsFor: '*jason-dispatch' stamp: 'cwp 12/20/2010 11:00'!
printValueWith: aJasonPrinter 
	self value! !

Object subclass: #JasonFormatter
	instanceVariableNames: 'eol tab space indent whitespace'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jason-Core'!

!JasonFormatter class methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2010 14:18'!
compact
	^ self new! !

!JasonFormatter methodsFor: 'private' stamp: 'cwp 12/20/2010 13:14'!
clearWhitespace
	self whitespace: ''! !

!JasonFormatter methodsFor: 'private' stamp: 'cwp 12/20/2010 13:18'!
decreaseIndent
	indent := indent allButLast: self tab size! !

!JasonFormatter methodsFor: 'accessing' stamp: 'cwp 12/20/2010 12:39'!
eol
	^ eol! !

!JasonFormatter methodsFor: 'accessing' stamp: 'cwp 12/20/2010 12:39'!
eol: anObject
	eol := anObject! !

!JasonFormatter methodsFor: 'private' stamp: 'cwp 12/20/2010 14:14'!
generateWhitespace
	whitespace := eol, indent! !

!JasonFormatter methodsFor: 'private' stamp: 'cwp 12/20/2010 13:18'!
increaseIndent
	indent := indent , self tab! !

!JasonFormatter methodsFor: 'formatting' stamp: 'cwp 12/20/2010 13:20'!
indent: anInteger
	anInteger = 0
		ifTrue: [ 
			self space: ''.
			self eol: ''.
			self tab: '' ]
		ifFalse: [ 
			self tab: (String new: anInteger).
			self tab atAllPut: Character space.
			self eol: String cr.
			self space: String space ]! !

!JasonFormatter methodsFor: 'initialize-release' stamp: 'cwp 12/20/2010 12:56'!
initialize
	eol := tab := space := indent := whitespace := ''! !

!JasonFormatter methodsFor: 'private' stamp: 'cwp 12/20/2010 13:04'!
printWhitespaceOn: s
	s nextPutAll: self whitespace.
	self whitespace: ''! !

!JasonFormatter methodsFor: 'accessing' stamp: 'cwp 12/20/2010 12:39'!
space
	^ space! !

!JasonFormatter methodsFor: 'accessing' stamp: 'cwp 12/20/2010 12:39'!
space: anObject
	space := anObject! !

!JasonFormatter methodsFor: 'accessing' stamp: 'cwp 12/20/2010 12:39'!
tab
	^ tab! !

!JasonFormatter methodsFor: 'accessing' stamp: 'cwp 12/20/2010 12:39'!
tab: anObject
	tab := anObject! !

!JasonFormatter methodsFor: 'accessing' stamp: 'cwp 12/20/2010 12:47'!
whitespace
	^ whitespace! !

!JasonFormatter methodsFor: 'accessing' stamp: 'cwp 12/20/2010 12:47'!
whitespace: anObject
	whitespace := anObject! !

Object subclass: #JasonPrinter
	instanceVariableNames: 'stream formatter separator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jason-Core'!

!JasonPrinter class methodsFor: 'as yet unclassified' stamp: 'cwp 12/20/2010 08:13'!
on: aWriteStream
	^ self basicNew 
		initializeWithStream: aWriteStream;
		yourself! !

!JasonPrinter methodsFor: 'public' stamp: 'cwp 12/20/2010 13:31'!
array: aBlock
	self formatter: formatter array: aBlock! !

!JasonPrinter methodsFor: 'formatting' stamp: 'cwp 12/20/2010 13:53'!
compact: aBlock
	| oldFormatter |
	oldFormatter := formatter.
	[formatter := JasonFormatter new.
	aBlock value] ensure: 
		[formatter := oldFormatter]! !

!JasonPrinter methodsFor: 'public' stamp: 'cwp 12/20/2010 13:55'!
compactArray: aBlock
	self 
		formatter: JasonFormatter compact 
		array: aBlock! !

!JasonPrinter methodsFor: 'public' stamp: 'cwp 12/20/2010 13:55'!
compactObject: aBlock
	self 
		formatter: JasonFormatter compact 
		object: aBlock! !

!JasonPrinter methodsFor: 'private' stamp: 'cwp 12/20/2010 14:15'!
decreaseIndent
	formatter decreaseIndent.
	separator = ''
		ifTrue: [ formatter clearWhitespace ]
		ifFalse: [ formatter generateWhitespace ].
	formatter printWhitespaceOn: stream.! !

!JasonPrinter methodsFor: 'formatting' stamp: 'cwp 12/20/2010 12:41'!
eol: aString
	formatter eol: aString! !

!JasonPrinter methodsFor: 'types' stamp: 'cwp 12/20/2010 09:01'!
escape: aCharacter
	stream 
		nextPut: $\;
		nextPut: aCharacter
		! !

!JasonPrinter methodsFor: 'public' stamp: 'cwp 12/20/2010 13:48'!
formatter: aFormatter array: aBlock

	self printSeparator.
	self use: aFormatter during:
		[stream nextPut: $[.
		self increaseIndent.
		aBlock value.
		self decreaseIndent.
		stream nextPut: $]].
	self separateWithComma
	! !

!JasonPrinter methodsFor: 'public' stamp: 'cwp 12/20/2010 13:48'!
formatter: aFormatter object: aBlock
	self printSeparator.
	self use: aFormatter during:
		[stream nextPut: ${.
		self increaseIndent.
		aBlock value.
		self decreaseIndent.
		stream nextPut: $}].
	self separateWithComma! !

!JasonPrinter methodsFor: 'types' stamp: 'cwp 12/20/2010 09:29'!
hexEscape: aCharacter
	stream nextPutAll: '\u00'.
	aCharacter asciiValue printOn: stream base: 16 showRadix: false.! !

!JasonPrinter methodsFor: 'private' stamp: 'cwp 12/20/2010 14:15'!
increaseIndent
	formatter increaseIndent.
	formatter generateWhitespace .! !

!JasonPrinter methodsFor: 'formatting' stamp: 'cwp 12/20/2010 13:20'!
indent: anInteger
	formatter indent: anInteger! !

!JasonPrinter methodsFor: 'initialize-release' stamp: 'cwp 12/20/2010 12:56'!
initializeWithStream: aWriteStream
	stream := aWriteStream.
	formatter := JasonFormatter new.
	separator := ''.
! !

!JasonPrinter methodsFor: 'public' stamp: 'cwp 12/20/2010 13:00'!
name: aString value: anObject
	self printSeparator.
	self printString: aString.
	stream nextPut: $:.
	stream nextPutAll: formatter space.
	anObject printValueWith: self.
	self separateWithComma! !

!JasonPrinter methodsFor: 'public' stamp: 'cwp 12/20/2010 13:39'!
object: aBlock
	self formatter: formatter object: aBlock! !

!JasonPrinter methodsFor: 'types' stamp: 'cwp 12/20/2010 08:35'!
printArray: anArray 
	self array: [anArray do: [:ea | self value: ea]]! !

!JasonPrinter methodsFor: 'types' stamp: 'cwp 12/20/2010 08:26'!
printBoolean: aBoolean
	aBoolean printOn: stream! !

!JasonPrinter methodsFor: 'types' stamp: 'cwp 12/20/2010 09:29'!
printCharacter: aCharacter
	aCharacter = $" ifTrue: [^ self escape: $"].
	aCharacter = $\ ifTrue: [^ self escape: $\].
	aCharacter = Character backspace ifTrue: [^ self escape: $b].
	aCharacter = Character newPage ifTrue: [^ self escape: $f].
	aCharacter = Character lf ifTrue: [^ self escape: $n].
	aCharacter = Character cr ifTrue: [^ self escape: $r].
	aCharacter = Character tab ifTrue: [^ self escape: $t].
	aCharacter asciiValue < 32 ifTrue: [^ self hexEscape: aCharacter].
	stream nextPut: aCharacter! !

!JasonPrinter methodsFor: 'types' stamp: 'cwp 12/20/2010 08:18'!
printInteger: anInteger
	anInteger printOn: stream! !

!JasonPrinter methodsFor: 'types' stamp: 'cwp 12/20/2010 08:28'!
printNull
	stream nextPutAll: 'null'! !

!JasonPrinter methodsFor: 'types' stamp: 'cwp 12/20/2010 08:45'!
printObject: aDictionary 
	self object:
		[aDictionary keysAndValuesDo: 
			[:key :value |
			self name: key value: value]]! !

!JasonPrinter methodsFor: 'private' stamp: 'cwp 12/20/2010 13:05'!
printSeparator
	stream nextPutAll: separator.
	separator := ''.
	formatter printWhitespaceOn: stream! !

!JasonPrinter methodsFor: 'types' stamp: 'cwp 12/20/2010 08:53'!
printString: aString
	stream nextPut: $".
	aString do: [:char | self printCharacter: char].
	stream nextPut: $"! !

!JasonPrinter methodsFor: 'private' stamp: 'cwp 12/20/2010 14:14'!
separateWithComma
	separator := ','.
	formatter generateWhitespace ! !

!JasonPrinter methodsFor: 'formatting' stamp: 'cwp 12/20/2010 12:44'!
space: aString
	formatter space: aString! !

!JasonPrinter methodsFor: 'formatting' stamp: 'cwp 12/20/2010 12:43'!
tab: aString
	formatter tab: aString! !

!JasonPrinter methodsFor: 'private' stamp: 'cwp 12/20/2010 13:42'!
use: aFormatter during: aBlock
	| old |
	old := formatter.
	[formatter := aFormatter.
	aBlock value] ensure: 
		[ formatter := old ]! !

!JasonPrinter methodsFor: 'public' stamp: 'cwp 12/20/2010 10:26'!
value: anObject
	self printSeparator.
	anObject printValueWith: self.
	self separateWithComma! !

!Dictionary methodsFor: '*jason-dispatch' stamp: 'cwp 12/20/2010 08:44'!
printValueWith: aJasonPrinter 
	aJasonPrinter printObject: self! !

!UndefinedObject methodsFor: '*jason-dispatch' stamp: 'cwp 12/20/2010 08:27'!
printValueWith: aJasonPrinter 
	aJasonPrinter printNull! !

TestCase subclass: #JasonPrintingTest
	instanceVariableNames: 'out ws'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Jason-Tests'!

!JasonPrintingTest methodsFor: 'asserting' stamp: 'cwp 12/20/2010 13:41'!
assertResultIs: aString
	| result |
	result := ws contents.
	self assert: result = aString.! !

!JasonPrintingTest methodsFor: 'running' stamp: 'cwp 12/20/2010 08:09'!
setUp
	ws := String new writeStream.
	out := JasonPrinter on: ws.
	! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testArrayOneValue
	out array: [ out value: 'a' ].
	self assertResultIs: '["a"]'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testArrayTwoValues
	out
		array: [ 
			out value: 'a'.
			out value: 'b' ].
	self assertResultIs: '["a","b"]'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testArrayValue
	out value: #('a').
	self assertResultIs: '["a"]'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 14:19'!
testArrayWithCompactArray
	out indent: 2.
	out array:
		[out compactArray: 
			[out value: 3.
			out value: 4]].
	self assertResultIs:
'[
  [3,4]
]'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testArrayWithObject
	out array: [ out object: [ out name: 'griffle' value: 'zork' ] ].
	self assertResultIs: '[{"griffle":"zork"}]'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 14:16'!
testArrayWithOneCompactObject
	out indent: 2.
	out array:
		[out compactObject:
			[out name: 'griffle' value: 3.
			out name: 'plonk' value: 4]].
	self assertResultIs:
'[
  {"griffle":3,"plonk":4}
]'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 14:15'!
testArrayWithTwoCompactArrays
	out indent: 2.
	out array:
		[out compactArray:
			[out value: 3.
			out value: 4].
		out compactArray:
			[out value: 5.
			out value: 6]].
	self assertResultIs:
'[
  [3,4],
  [5,6]
]'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 14:19'!
testArrayWithTwoCompactObjects
	out indent: 2.
	out array:
		[out compactObject:
			[out name: 'griffle' value: 3.
			out name: 'plonk' value: 4].
		out compactObject:
			[out name: 'griffle' value: 5.
			out name: 'plonk' value: 6]].
	self assertResultIs:
'[
  {"griffle":3,"plonk":4},
  {"griffle":5,"plonk":6}
]'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testArrayWithTwoObjects
	out
		array: [ 
			out object: [ out name: 'griffle' value: 'zork' ].
			out object: [ out name: 'plonk' value: 'nerf' ] ].
	self assertResultIs: '[{"griffle":"zork"},{"plonk":"nerf"}]'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testArrayZeroValues
	out array: [  ].
	self assertResultIs: '[]'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testBigInteger
	out value: 1073741824.
	self assertResultIs: '1073741824'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testDictionaryValue
	| dict |
	dict := (Dictionary new)
		at: 'a' put: 2;
		yourself.
	out value: dict.
	self assertResultIs: '{"a":2}'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testEmbeddedBackslash
	out value: '\'.
	self assertResultIs: '"\\"'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testEmbeddedBackspace
	out value: Character backspace asString.
	self assertResultIs: '"\b"'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testEmbeddedCarriageReturn
	out value: Character cr asString.
	self assertResultIs: '"\r"'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testEmbeddedControlCharacter
	out value: Character arrowLeft asString.
	self assertResultIs: '"\u001C"'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testEmbeddedFormfeed
	out value: Character newPage asString.
	self assertResultIs: '"\f"'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testEmbeddedLinefeed
	out value: Character lf asString.
	self assertResultIs: '"\n"'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testEmbeddedQuote
	out value: '"'.
	self assertResultIs: '"\""'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testEmbeddedTab
	out value: Character tab asString.
	self assertResultIs: '"\t"'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testEol
	out eol: '?'.
	out object: [ out name: 'a' value: [ out object: [ out name: 'b' value: 3 ] ] ].
	self assertResultIs: '{?"a":{?"b":3?}?}'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testFalse
	out value: false.
	self assertResultIs: 'false'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testIndent0
	out indent: 2.
	out indent: 0.
	out array: [ out array: [ out value: 3 ] ].
	self assertResultIs: '[[3]]'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testNil
	out value: nil.
	self assertResultIs: 'null'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testObjectOnePair
	out object: [ out name: 'a' value: 3 ].
	self assertResultIs: '{"a":3}'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testObjectTwoPairs
	out
		object: [ 
			out
				name: 'a' value: 3;
				name: 'b' value: 4 ].
	self assertResultIs: '{"a":3,"b":4}'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testObjectWithArray0
	out object: [ out name: 'a' value: [ out array: [  ] ] ].
	self assertResultIs: '{"a":[]}'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testObjectWithArray1
	out object: [ out name: 'a' value: [ out array: [ out value: 3 ] ] ].
	self assertResultIs: '{"a":[3]}'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testObjectWithArray2
	out indent: 2.
	out
		object: [ 
			out
				name: 'a'
				value: [ 
					out
						array: [ 
							out
								value: 3;
								value: 4 ] ] ].
	self
		assertResultIs:
			'{
  "a": [
    3,
    4
  ]
}'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testObjectWithObject0
	out object: [ out name: 'a' value: [ out object: [  ] ] ].
	self assertResultIs: '{"a":{}}'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testObjectWithObject1
	out object: [ out name: 'a' value: [ out object: [ out name: 'b' value: 3 ] ] ].
	self assertResultIs: '{"a":{"b":3}}'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testObjectZeroPairs
	out object: [  ].
	self assertResultIs: '{}'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testPrettyArrayWithObject
	out indent: 2.
	out array: [ out object: [ out name: 'griffle' value: 'zork' ] ].
	self
		assertResultIs:
			'[
  {
    "griffle": "zork"
  }
]'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testPrettyArrayWithOneValue
	out indent: 2.
	out array: [ out value: 3 ].
	self
		assertResultIs:
			'[
  3
]'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testPrettyArrayWithTwoObjects
	out indent: 2.
	out
		array: [ 
			out object: [ out name: 'griffle' value: 'zork' ].
			out object: [ out name: 'plonk' value: 'nerf' ] ].
	self
		assertResultIs:
			'[
  {
    "griffle": "zork"
  },
  {
    "plonk": "nerf"
  }
]'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testPrettyArrayWithTwoValues
	out indent: 2.
	out
		array: [ 
			out
				value: 3;
				value: 4 ].
	self
		assertResultIs:
			'[
  3,
  4
]'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testPrettyArrayWithZeroValues
	out indent: 2.
	out array: [  ].
	self assertResultIs: '[]'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testPrettyObjectOnePair
	out indent: 2.
	out object: [ out name: 'a' value: 3 ].
	self
		assertResultIs:
			'{
  "a": 3
}'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testPrettyObjectTwoPairs
	out indent: 2.
	out
		object: [ 
			out
				name: 'a' value: 3;
				name: 'b' value: 4 ].
	self
		assertResultIs:
			'{
  "a": 3,
  "b": 4
}'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testPrettyObjectWithArray0
	out indent: 2.
	out object: [ out name: 'a' value: [ out array: [  ] ] ].
	self
		assertResultIs:
			'{
  "a": []
}'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testPrettyObjectWithArray1
	out indent: 2.
	out object: [ out name: 'a' value: [ out array: [ out value: 3 ] ] ].
	self
		assertResultIs:
			'{
  "a": [
    3
  ]
}'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testPrettyObjectWithObject0
	out indent: 2.
	out object: [ out name: 'a' value: [ out object: [  ] ] ].
	self
		assertResultIs:
			'{
  "a": {}
}'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testPrettyObjectWithObject1
	out indent: 2.
	out object: [ out name: 'a' value: [ out object: [ out name: 'b' value: 3 ] ] ].
	self
		assertResultIs:
			'{
  "a": {
    "b": 3
  }
}'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testPrettyObjectZeroPairs
	out indent: 2.
	out object: [  ].
	self assertResultIs: '{}'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testSmallInteger
	out value: 2.
	self assertResultIs: '2'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testSpace
	out space: '?'.
	out object: [ out name: 'a' value: [ out object: [ out name: 'b' value: 3 ] ] ].
	self assertResultIs: '{"a":?{"b":?3}}'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testString
	out value: 'griffle'.
	self assertResultIs: '"griffle"'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testTab
	out tab: '?'.
	out object: [ out name: 'a' value: [ out object: [ out name: 'b' value: 3 ] ] ].
	self assertResultIs: '{?"a":{??"b":3?}}'! !

!JasonPrintingTest methodsFor: 'tests' stamp: 'cwp 12/20/2010 13:27'!
testTrue
	out value: true.
	self assertResultIs: 'true'! !

!Boolean methodsFor: '*jason-dispatch' stamp: 'cwp 12/20/2010 08:26'!
printValueWith: aJasonPrinter 
	aJasonPrinter printBoolean: self! !

!SequenceableCollection methodsFor: '*jason-dispatch' stamp: 'cwp 12/20/2010 08:34'!
printValueWith: aJasonPrinter 
	aJasonPrinter printArray: self! !

!Integer methodsFor: '*jason-dispatch' stamp: 'cwp 12/20/2010 08:18'!
printValueWith: aJasonPrinter 
	aJasonPrinter printInteger: self! !

!String methodsFor: '*jason-dispatch' stamp: 'cwp 12/20/2010 08:19'!
printValueWith: aJasonPrinter 
	aJasonPrinter printString: self! !
